package com.gzlh.device.plc.client;

import io.netty.channel.ChannelHandler;
import io.netty.channel.ChannelHandlerContext;
import io.netty.channel.SimpleChannelInboundHandler;
import lombok.extern.slf4j.Slf4j;

@Slf4j
@ChannelHandler.Sharable
public class PlcClientHandler extends SimpleChannelInboundHandler<String> {

    private PlcNettyConfig ledNettyConfig;

    public PlcClientHandler(PlcNettyConfig ledNettyConfig) {
        this.ledNettyConfig = ledNettyConfig;
    }

    @Override
    protected void channelRead0(ChannelHandlerContext ctx, String msg) throws Exception {
        log.info("PLC 客户端收到消息：" + msg);

    }

    @Override
    public void channelInactive(ChannelHandlerContext ctx) throws Exception {
        log.error("PLC 客户端 连接断开，进行重连");
        ledNettyConfig.connect();
    }

    @Override
    public void exceptionCaught(ChannelHandlerContext ctx, Throwable cause) throws Exception {
        cause.printStackTrace();
        ctx.close();
    }

}

